﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SharQL.Algebra.AstUtils.Visitor;

namespace SharQL.Algebra.AstUtils.Tests
{
	/// <summary>
	/// Summary description for BlankNodeLabelValidatorTest
	/// </summary>
	[TestClass]
	public class BlankNodeLabelValidatorTest
	{
		public BlankNodeLabelValidatorTest()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		//
		// You can use the following additional attributes as you write your tests:
		//
		// Use ClassInitialize to run code before running the first test in the class
		// [ClassInitialize()]
		// public static void MyClassInitialize(TestContext testContext) { }
		//
		// Use ClassCleanup to run code after all tests in a class have run
		// [ClassCleanup()]
		// public static void MyClassCleanup() { }
		//
		// Use TestInitialize to run code before running each test 
		// [TestInitialize()]
		// public void MyTestInitialize() { }
		//
		// Use TestCleanup to run code after each test has run
		// [TestCleanup()]
		// public void MyTestCleanup() { }
		//
		#endregion

		[TestMethod]
		[ExpectedException(typeof(InvalidOperationException))]
		public void TestIllegalBnodeLabeling1()
		{
			string query = @"SELECT * { { _:a <a:b> ?a } { _:a <a:c> ?b  }}";
			Parser p = new Parser();
			Assert.IsTrue(p.Parse(query));
			Assert.IsNotNull(p.AstRoot);
			p.AstRoot.Accept(new BlankNodeLabelValidatorVisitor());
		}

		[TestMethod]
		[ExpectedException(typeof(InvalidOperationException))]
		public void TestIllegalBnodeLabeling2()
		{
			string query = @"SELECT * { { _:a <a:b> ?a } UNION { _:a <a:c> ?b  }}";
			Parser p = new Parser();
			Assert.IsTrue(p.Parse(query));
			Assert.IsNotNull(p.AstRoot);
			p.AstRoot.Accept(new BlankNodeLabelValidatorVisitor());
		}

		[TestMethod]
		[ExpectedException(typeof(InvalidOperationException))]
		public void TestIllegalBnodeLabeling3()
		{
			string query = @"SELECT * { { _:a <a:b> ?a } OPTIONAL { _:a <a:c> ?b  }}";
			Parser p = new Parser();
			Assert.IsTrue(p.Parse(query));
			Assert.IsNotNull(p.AstRoot);
			p.AstRoot.Accept(new BlankNodeLabelValidatorVisitor());
		}

		[TestMethod]
		public void TestLegalBnodeLabeling1()
		{
			string query = @"SELECT * { _:a <a:b> ?a . _:a <a:c> ?b }";
			Parser p = new Parser();
			Assert.IsTrue(p.Parse(query));
			Assert.IsNotNull(p.AstRoot);
			p.AstRoot.Accept(new BlankNodeLabelValidatorVisitor());
		}

		[TestMethod]
		public void TestLegalBnodeLabeling2()
		{
			string query = @"SELECT * { { _:a <a:b> ?a } { _:b <a:c> ?b  }}";
			Parser p = new Parser();
			Assert.IsTrue(p.Parse(query));
			Assert.IsNotNull(p.AstRoot);
			p.AstRoot.Accept(new BlankNodeLabelValidatorVisitor());
		}
	}
}
