﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SharQL.Ast;
using SharQL.Algebra.AstUtils.Visitor;
using SharQL.Ast.Visitor;

namespace SharQL.Algebra.AstUtils.Tests
{
    /// <summary>
    /// Summary description for CombinedTest
    /// </summary>
    [TestClass]
    public class CombinedTest
    {
        public CombinedTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestCombinedQuery()
        {
            Parser parser = new Parser();
            Assert.IsTrue(parser.Parse("SELECT DISTINCT * WHERE {{?a <a:b> 'c' . <a:a> ?a 'c'} UNION {<a:a> <a:b> ?c}} ORDER BY ?a ?b ?c OFFSET 3 LIMIT 5"));

            INode root = parser.AstRoot;

            Visualizer.Visualize.PrepareAst(root);

            root.Accept(new ListReificationVisitor(), VisitorOrder.ChildrenBeforeParent);
            root.Accept(new BlankNodeReificationVisitor(), VisitorOrder.ChildrenBeforeParent);
            root.Accept(new TriplesSameSubjectResolverVisitor(), VisitorOrder.ParentBeforeChildren);
            root.Accept(new ExpansionVisitor(), VisitorOrder.ChildrenBeforeParent);
            root.Accept(new LiteralExplicatorVisitor(), VisitorOrder.ChildrenBeforeParent);

            Visualizer.Visualize.CompareAst(root);
        }
    }
}
