﻿using System.Collections.Generic;
using SharQL.Ast;
using SharQL.Ast.Nodes;

namespace SharQL.Algebra.Tests.Utils
{
	internal static class TripleUtils
	{
		public static INode GetSubject(TriplesBlockNode triple)
		{
			TriplesSameSubjectNode tssn = triple.Children[0] as TriplesSameSubjectNode;
			if (tssn != null)
			{
				return tssn.Children[0];
			}
			return null;
		}

		public static INode GetPredicate(TriplesBlockNode triple)
		{
			TriplesSameSubjectNode tssn = triple.Children[0] as TriplesSameSubjectNode;
			if (tssn != null)
			{
				PropertyListNode pln = tssn.Children[2] as PropertyListNode;
				if (pln != null)
				{
					return pln.Children[0];
				}
			}
			return null;
		}

		public static INode GetObject(TriplesBlockNode triple)
		{
			TriplesSameSubjectNode tssn = triple.Children[0] as TriplesSameSubjectNode;
			if (tssn != null)
			{
				PropertyListNode pln = tssn.Children[2] as PropertyListNode;
				if (pln != null)
				{
					ObjectListNode oln = pln.Children[1] as ObjectListNode;
					if (oln != null)
					{
						return oln.Children[0];
					}
				}
			}
			return null;
		}

		public static TriplesBlockNode[] FetchSubsequentTriples(TriplesBlockNode firstTriple)
		{
			List<TriplesBlockNode> triples = new List<TriplesBlockNode>();

			TriplesBlockNode current = firstTriple;

			while (current != null)
			{
				triples.Add(current);
				current = current.Children[1] as TriplesBlockNode;
			}

			return triples.ToArray();
		}
	}
}
