﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SharQL.Ast.Nodes;

namespace SharQL.Algebra.QueryStructure.Tests
{
    /// <summary>
    /// Summary description for OrderByTest
    /// </summary>
    [TestClass]
    public class OrderByTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestOrderByPresent1()
        {
            Parser parser = new Parser();
            Assert.IsTrue(parser.Parse("SELECT * {} ORDER BY ?a ASC(?b) DESC(?c)"));
            Query query = QueryTransformer.Transform(parser.AstRoot as QueryNode);

            SelectQueryDescription description = query.Description as SelectQueryDescription;
            Assert.AreEqual(3, description.OrderConditions.Count);
            Assert.IsInstanceOfType(description.OrderConditions[0].Value, typeof(VarNode));
            Assert.IsInstanceOfType(description.OrderConditions[1].Value, typeof(VarNode));
            Assert.IsInstanceOfType(description.OrderConditions[2].Value, typeof(VarNode));
            Assert.AreEqual(OrderTypes.Ascending, description.OrderConditions[0].Type);
            Assert.AreEqual(OrderTypes.Ascending, description.OrderConditions[1].Type);
            Assert.AreEqual(OrderTypes.Descending, description.OrderConditions[2].Type);
            Assert.AreEqual("a", ((VarNode)description.OrderConditions[0].Value).Value);
            Assert.AreEqual("b", ((VarNode)description.OrderConditions[1].Value).Value);
            Assert.AreEqual("c", ((VarNode)description.OrderConditions[2].Value).Value);
        }
    }
}
