﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using SharQL.Ast.Nodes;

namespace SharQL.Algebra.QueryStructure.Tests
{
    /// <summary>
    /// Summary description for StarVarListTest
    /// </summary>
    [TestClass]
    public class StarVarListTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestStar()
        {
            Parser parser = new Parser();
            parser.Parse("SELECT * {}");
            Query query = QueryTransformer.Transform(parser.AstRoot as QueryNode);

            Assert.AreEqual(0, (query.Description as SelectQueryDescription).Variables.Count);
        }

        [TestMethod]
        public void TestVariableList()
        {
            Parser parser = new Parser();
            parser.Parse("SELECT ?a ?b ?c {}");
            Query query = QueryTransformer.Transform(parser.AstRoot as QueryNode);

            SelectQueryDescription description = query.Description as SelectQueryDescription;
            Assert.AreEqual(3, description.Variables.Count);
            Assert.AreEqual("a", description.Variables[0]);
            Assert.AreEqual("b", description.Variables[1]);
            Assert.AreEqual("c", description.Variables[2]);
        }
    }
}
