﻿using System.Diagnostics;
using System.Windows.Forms;
using SharQL.Ast;

namespace SharQL.Algebra.Visualizer
{
	public static class Visualize
	{
		private static TreeNode preparedRoot = null;

		[Conditional("DEBUG")]
		public static void Ast(INode root)
		{
			Ast(root, false);
		}

		[Conditional("DEBUG")]
		public static void Ast(INode root, bool showNulls)
		{
			TreeBuilderVisitor visitor = new TreeBuilderVisitor() { ShowNulls = showNulls };
			root.Accept(visitor);

			VisualizerForm frm = new VisualizerForm();
			frm.Nodes1.Add(visitor.TreeNodes[root]);
			frm.ShowDialog();
		}

		[Conditional("DEBUG")]
		public static void Ast(INode root1, INode root2)
		{
			Ast(root1, root2, false);
		}

		[Conditional("DEBUG")]
		public static void Ast(INode root1, INode root2, bool showNulls)
		{
			TreeBuilderVisitor visitor1 = new TreeBuilderVisitor() { ShowNulls = showNulls };
			root1.Accept(visitor1);
			TreeBuilderVisitor visitor2 = new TreeBuilderVisitor() { ShowNulls = showNulls };
			root2.Accept(visitor2);

			VisualizerForm frm = new VisualizerForm();
			frm.Nodes1.Add(visitor1.TreeNodes[root1]);
			frm.Nodes2.Add(visitor2.TreeNodes[root2]);
			frm.ShowDialog();
		}

		[Conditional("DEBUG")]
		public static void PrepareAst(INode root1)
		{
			PrepareAst(root1, false);
		}

		[Conditional("DEBUG")]
		public static void PrepareAst(INode root1, bool showNulls)
		{
			TreeBuilderVisitor visitor1 = new TreeBuilderVisitor() { ShowNulls = showNulls };
			root1.Accept(visitor1);
			preparedRoot = visitor1.TreeNodes[root1];
		}

		[Conditional("DEBUG")]
		public static void CompareAst(INode root2)
		{
			CompareAst(root2, false);
		}

		[Conditional("DEBUG")]
		public static void CompareAst(INode root2, bool showNulls)
		{
			TreeBuilderVisitor visitor2 = new TreeBuilderVisitor() { ShowNulls = showNulls };
			root2.Accept(visitor2);

			VisualizerForm frm = new VisualizerForm();
			frm.Nodes1.Add(preparedRoot ?? new TreeNode());
			frm.Nodes2.Add(visitor2.TreeNodes[root2]);
			frm.ShowDialog();
		}
	}
}
