﻿using System;
using System.Collections.Generic;

namespace SharQL.Algebra.QueryStructure
{
    public enum DistinctReducedModifiers { None, Distinct, Reduced }

    public class SelectQueryDescription : QueryDescriptionBase
    {
        public DistinctReducedModifiers DistinctReducedModifier { get; set; }
        public List<string> Variables { get; set; }
        public List<string> DefaultGraphs { get; set; }
        public List<string> NamedGraphs { get; set; }
        public List<OrderCondition> OrderConditions { get; set; }
        public Nullable<int> Limit { get; set; }
        public Nullable<int> Offset { get; set; }

        public SelectQueryDescription()
        {
            Variables = new List<string>();
            DefaultGraphs = new List<string>();
            NamedGraphs = new List<string>();
			Limit = null;
			Offset = null;
        }
    }
}
