﻿using SharQL.Ast;
using SharQL.Algebra.QueryStructure;
using Microsoft.Ceres.Evaluation.Operators.Graphs;
using System.Collections.Generic;

namespace SharQL.Component
{
	/// <summary>
	/// Service for handling SPARQL queries. Provides parsing as well as conversion
	/// to operator trees.
	/// </summary>
	public interface ISparqlQueryService
	{
        /// <summary>
        /// Executes the given SPARQL query.
        /// </summary>
        /// <param name="query">The SPARQL query to be executed.</param>
        /// <returns>XML-formatted result set.</returns>
        string ExecuteQuery(string query);

        /// <summary>
        /// A list of errors found while parsing the last query.
        /// </summary>
        IEnumerable<string> Errors { get; }
	}
}
