﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SharQL.Ast
{
	internal class NodeCollection : IList<INode>
	{
		#region Private Members

		private List<INode> list;

		#endregion

		internal NodeCollection()
		{
			list = new List<INode>();
		}

		#region IList<INode> Members

		public int IndexOf(INode item)
		{
			return list.IndexOf(item);
		}

		public void Insert(int index, INode item)
		{
			list.Insert(index, item);
		}

		public void RemoveAt(int index)
		{
			list.RemoveAt(index);
		}

		public INode this[int index]
		{
			get
			{
				return list[index];
			}
			set
			{
				list[index] = value;
			}
		}

		#endregion

		#region ICollection<INode> Members

		public void Add(INode item)
		{
			list.Add(item);
		}

		public void Clear()
		{
			list.Clear();
		}

		public bool Contains(INode item)
		{
			return list.Contains(item);
		}

		public void CopyTo(INode[] array, int arrayIndex)
		{
			list.CopyTo(array, arrayIndex);
		}

		public int Count
		{
			get { return list.Count; }
		}

		public bool IsReadOnly
		{
			get { return false; }
		}

		public bool Remove(INode item)
		{
			return list.Remove(item);
		}

		#endregion

		#region IEnumerable<INode> Members

		public IEnumerator<INode> GetEnumerator()
		{
			return list.GetEnumerator();
		}

		#endregion

		#region IEnumerable Members

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			return list.GetEnumerator();
		}

		#endregion
	}
}
