﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SharQL.Ast.Nodes
{
	public class PrefixDeclNode : NodeBase
	{
		public string Namespace { get; set; }
		public bool IsBaseDecl { get { return Namespace == null; } }
		public IriRefNode IriRef { get { return children[0] as IriRefNode; } }

		public PrefixDeclNode(NodeBase iriRef)
			: this(null, iriRef)
		{ }

		public PrefixDeclNode(string ns, NodeBase iriRef)
			: base(iriRef)
		{
			if (!string.IsNullOrEmpty(ns))
				this.Namespace = ns.TrimEnd(':');
			else
				this.Namespace = ns;
		}
	}
}
