﻿using System;
using SharQL.Ast.Nodes;

namespace SharQL.Ast.Visitor
{
	internal class EscapeSequenceResolverVisitor : IVisitor
	{
		#region IParserVisitor Members

		public Action<INode> this[Type nodeType]
		{
			get 
			{
				if (nodeType == typeof(StringLiteralNode))
					return resolveEscapeSequence;
				else
					return noOp;
			}
		}

		#endregion

		private void resolveEscapeSequence(INode node)
		{
			StringLiteralNode n = node as StringLiteralNode;
			if (n != null)
			{
				string escapedString = n.Value;
				string resolvedString = Utils.EscapeSequenceResolver.ResolveCommonEscapeSequences(escapedString);
				n.Value = resolvedString;
			}
		}

		private void noOp(INode node)
		{
			// Ignore
		}
	}
}
