﻿using System;
using SharQL.Ast;

namespace SharQL.Ast.Visitor
{
	/// <summary>
	/// Interface for any visitor that wants to traverse the AST.
	/// </summary>
	public interface IVisitor
	{
		/// <summary>
		/// Gets an <see cref="Action&lt;INode&gt;"/> delegate 
		/// for visiting the specified node type.
		/// </summary>
		/// <param name="nodeType">The type of node to be 
		/// visited.</param>
		/// <returns>an <see cref="Action&lt;INode&gt;"/> delegate 
		/// for visiting the node</returns>
		Action<INode> this[Type nodeType] { get; }
	}
}
