﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Babel.ParserGenerator;
using System.Diagnostics;

namespace SharQL.Utils
{
    /// <summary>
    /// Represents a lexical location.
    /// </summary>
    /// <remarks>Corrects a merge bug in the MPPG LexLocation class.</remarks>
    public class CustomLexLocation : IMerge<CustomLexLocation>
    {
        public int sLin; // Start line
        public int sCol; // Start column
        public int eLin; // End line
        public int eCol; // End column

        public CustomLexLocation() 
        {
        }
        
        public CustomLexLocation(int sl, int sc, int el, int ec)
        {
            sLin=sl; 
            sCol=sc; 
            eLin=el; 
            eCol=ec;
        }

        public CustomLexLocation Merge(CustomLexLocation last)
        {
            // This part is missing from the MPPG LexLocation class
            if (last == null)
            {
                return this;
            }

            return new CustomLexLocation(sLin, sCol, last.eLin, last.eCol);
        }
    }
}
