﻿using SharQL.Ast.Visitor;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SharQL.Ast;
using System;
using SharQL.Ast.Nodes;

namespace SharQLTest
{
	/// <summary>
	///This is a test class for EscapeSequenceResolverVisitorTest and is intended
	///to contain all EscapeSequenceResolverVisitorTest Unit Tests
	///</summary>
	[TestClass]
	public class EscapeSequenceResolverVisitorTest
	{
		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion

		[TestMethod]
		public void EscapeSequenceResolverTest()
		{
			string escapedString, expected, actual;
			EscapeSequenceResolverVisitor visitor = new EscapeSequenceResolverVisitor();
			QueryNode qn;

			escapedString = @"This\n\nis\r\ra strange string\t\t";
			expected = "This\n\nis\r\ra strange string\t\t";
			qn = new QueryNode
			(
				new PrologueNode(null, null),
				new SelectQueryNode
				(
					new StringLiteralNode() { Value = escapedString },
					new IriRefNode() { Value = escapedString }
				)
			);
			qn.Accept(visitor);

			actual = ((StringLiteralNode)qn.Children[1].Children[0]).Value;
			Assert.AreEqual(expected, actual);

			actual = ((IriRefNode)qn.Children[1].Children[1]).Value;
			Assert.AreEqual(escapedString, actual);
		}
	}
}
